<?php
/**
 * Created by PhpStorm.
 * User: jackbravo
 * Date: 8/18/17
 * Time: 3:23 PM
 */

namespace Drupal\commerce_pagos_net\PluginForm;

use Drupal\commerce_payment\PluginForm\PaymentMethodAddForm;
use Drupal\Core\Form\FormStateInterface;

class PagosNetMethodAddForm extends PaymentMethodAddForm {

  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    $form = parent::buildConfigurationForm($form, $form_state); // TODO: Change the autogenerated stub

    $form['payment_details'] = $this->buildPagosNetMethodForm($form['payment_details'], $form_state);

    return $form;
  }

  /**
   * Builds the pagos net method form.
   *
   * @param array $element
   *   The target element.
   * @param \Drupal\Core\Form\FormStateInterface $form_state
   *   The current state of the complete form.
   *
   * @return array
   *   The built credit card form.
   */
  protected function buildPagosNetMethodForm(array $element, FormStateInterface $form_state) {
    // TODO: Fill default_value from the billing information fields
    $element['#attributes']['class'][] = 'pagos-net-form';

    $element['nit'] = [
      '#type' => 'textfield',
      '#title' => t('NIT'),
      '#required' => TRUE,
      '#maxlength' => 19, # TODO: get real size
      '#element_validate' => [['Drupal\Core\Render\Element\Number', 'validateNumber']],
      '#size' => 20,
    ];
    $element['fiscal_name'] = [
      '#type' => 'textfield',
      '#title' => t('Fiscal name'),
      '#required' => TRUE,
      '#maxlength' => 254,
      '#size' => 20,
    ];

    return $element;
  }

  public function submitConfigurationForm(array &$form, FormStateInterface $form_state) {
    $values = $form_state->getValue($form['payment_details']['#parents']);
    $this->entity->nit = $values['nit'];
    $this->entity->fiscal_name = $values['fiscal_name'];

    parent::submitConfigurationForm($form, $form_state);
  }

}